import { ChartLegend } from '@patternfly/react-charts';
import React from 'react';
import { ChartData, ChartLegendEntry, ChartLegendPosition, ChartPie, ChartTopSchemaElement, ChartLegendOrientation, PaddingProps } from '../types';
export declare type LegendComponentType = React.ReactElement<typeof ChartLegend>;
export declare const getInteractiveLegendForMultiSeries: (element: ChartTopSchemaElement, chartData: ChartData, setData: (data: ChartData) => void) => LegendComponentType;
export declare const getInteractiveLegendForSingleSeries: (element: ChartPie, serie: Record<string, string | number | boolean>[], setSerie: (serie: Record<string, string | number | boolean>[]) => void, chartData: ChartData) => LegendComponentType;
interface LegendProps {
    padding?: {
        top: number;
        bottom: number;
        left: number;
        right: number;
    };
    legendData?: ChartLegendEntry[];
    legendPosition?: ChartLegendPosition;
    legendOrientation?: ChartLegendOrientation;
    legendComponent?: LegendComponentType;
    domainPadding?: number;
}
export declare const getLegendProps: (element: ChartTopSchemaElement, chartData: ChartData, originalPadding: PaddingProps) => LegendProps;
export {};
