"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.paddingNumberToObject = exports.getBarWidthFromData = exports.axisFormatPreprocess = exports.wrapAt = exports.turncateAt = exports.snakeToSentence = void 0;
var snakeToSentence = function (str) {
    var sentence = str.toLowerCase().split('_');
    sentence[0] = sentence[0][0].toUpperCase() + sentence[0].slice(1);
    return sentence.join(' ');
};
exports.snakeToSentence = snakeToSentence;
var turncateAt = function (str, length) {
    return str.length > length ? "".concat(str.substring(0, length), "...") : str;
};
exports.turncateAt = turncateAt;
var wrapAt = function (str, length) {
    return str.length > length ? str.match(new RegExp(".{1,".concat(length, "}"), 'g')).join('\n') : str;
};
exports.wrapAt = wrapAt;
var axisFormatPreprocess = function (_a) {
    var _b = _a.wrapText, wrapText = _b === void 0 ? false : _b, _c = _a.turncateAtNumber, turncateAtNumber = _c === void 0 ? Infinity : _c, fnc = _a.fnc;
    return function (n) {
        n = wrapText
            ? (0, exports.wrapAt)(n.toString(), turncateAtNumber)
            : (0, exports.turncateAt)(n.toString(), turncateAtNumber);
        return fnc(n);
    };
};
exports.axisFormatPreprocess = axisFormatPreprocess;
var getBarWidthFromData = function (data, width) {
    var barNumber = (1 + data.length) * data[0].serie.length;
    var max = 150 / data.length;
    var min = 1;
    return Math.min(max, Math.max(min, width / barNumber));
};
exports.getBarWidthFromData = getBarWidthFromData;
var paddingNumberToObject = function (padding) {
    var _a, _b, _c, _d;
    return ({
        top: (_a = padding === null || padding === void 0 ? void 0 : padding.top) !== null && _a !== void 0 ? _a : 50,
        bottom: (_b = padding === null || padding === void 0 ? void 0 : padding.bottom) !== null && _b !== void 0 ? _b : 70,
        left: (_c = padding === null || padding === void 0 ? void 0 : padding.left) !== null && _c !== void 0 ? _c : 70,
        right: (_d = padding === null || padding === void 0 ? void 0 : padding.right) !== null && _d !== void 0 ? _d : 50
    });
};
exports.paddingNumberToObject = paddingNumberToObject;
//# sourceMappingURL=helpers.js.map