import { ChartTooltipProps } from '@patternfly/react-charts';
import React, { SyntheticEvent, FunctionComponent } from 'react';
export { ChartLabelFormatFunctionNames } from './labelFormat';
export { ChartAxisFormatFunctionNames } from './axisFormat';
export { ChartOnClickFunctionNames } from './onClick';
export { ChartTooltipComponentFunctionNames } from './tooltip';
export declare type ChartOnClickFunction = (event: SyntheticEvent<any, Event>, props: Record<string, any>) => any;
export declare type ChartAxisFormatFunction = (tick: string | number) => string;
export declare type ChartLabelFormatFunction = (data: {
    datum: Record<string, any>;
}) => string;
export declare type ChartTooltipComponentFunction = FunctionComponent<ChartTooltipProps>;
export declare type ChartStyleFunction = (props: any) => any;
export declare type ChartDataComponentFunction = React.ElementType;
export interface ChartFunctions {
    onClick?: Record<string, ChartOnClickFunction>;
    axisFormat?: Record<string, ChartAxisFormatFunction>;
    labelFormat?: Record<string, ChartLabelFormatFunction>;
    tooltipComponent?: Record<string, ChartTooltipComponentFunction>;
    style?: Record<string, ChartStyleFunction>;
    dataComponent?: Record<string, ChartDataComponentFunction>;
}
