import React, { useEffect, useRef } from 'react';
var ResponsiveContainer = function (_a) {
    var setWidth = _a.setWidth, height = _a.height, _b = _a.children, children = _b === void 0 ? [] : _b;
    var containerRef = useRef(null);
    var handleResize = function () {
        if (containerRef.current && containerRef.current.clientWidth) {
            setWidth(containerRef.current.clientWidth);
        }
        else {
            setWidth(500);
        }
    };
    useEffect(function () {
        handleResize();
        window.addEventListener('resize', handleResize);
        return function () {
            window.removeEventListener('resize', handleResize);
        };
    }, []);
    return (React.createElement("div", { ref: containerRef },
        React.createElement("div", { style: { height: height } }, children)));
};
export default ResponsiveContainer;
//# sourceMappingURL=ResponsiveContainer.js.map