var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { useEffect, useState } from 'react';
import { ChartPie as PFChartPie } from '@patternfly/react-charts';
import ResponsiveContainer from '../Common/ResponsiveContainer';
import { getInteractiveLegendForSingleSeries as getInteractiveLegend, getLegendProps } from '../Common/getLegendProps';
import { paddingNumberToObject } from '../Common/helpers';
var CreatePieChart = function (_a) {
    var _b, _c;
    var id = _a.id, schema = _a.schema, dataState = _a.dataState;
    var wrapper = schema.find(function (_a) {
        var i = _a.id;
        return i === id;
    });
    var data = dataState[0];
    var _d = useState(0), width = _d[0], setWidth = _d[1];
    var _e = useState([
        { hidden: true }
    ]), serie = _e[0], setSerie = _e[1];
    useEffect(function () {
        if (data.series.length > 0) {
            setSerie(data.series[0].serie.map(function (el) { return (__assign(__assign({}, el), { hidden: false })); }));
        }
    }, [data]);
    var props = __assign(__assign({ height: 300, y: 'y' }, wrapper === null || wrapper === void 0 ? void 0 : wrapper.props), ((_b = wrapper === null || wrapper === void 0 ? void 0 : wrapper.props) === null || _b === void 0 ? void 0 : _b.padding)
        ? { padding: paddingNumberToObject(wrapper.props.padding) }
        : {
            padding: {
                bottom: 70,
                left: 70,
                right: 50,
                top: 50
            }
        });
    var legendProps = getLegendProps(wrapper, data, props.padding);
    if ((_c = wrapper.legend) === null || _c === void 0 ? void 0 : _c.interactive) {
        legendProps = __assign(__assign({}, legendProps), { legendComponent: getInteractiveLegend(wrapper, serie, setSerie, data) });
        delete legendProps.legendData;
    }
    return (React.createElement(ResponsiveContainer, { setWidth: setWidth, height: props.height }, data.series.length > 0 && React.createElement(PFChartPie, __assign({ constrainToVisibleArea: true }, props, legendProps, { data: serie.map(function (el) {
            var _a;
            return el.hidden
                ? (__assign(__assign({}, el), (_a = {}, _a[props.y] = 0, _a)))
                : (__assign({}, el));
        }), key: data.series[0].name, name: data.series[0].name, width: width }))));
};
export default CreatePieChart;
//# sourceMappingURL=CreatePieChart.js.map